<template>
	<v-content>
		<v-container class="fill-height" fluid>
			<v-row align="center" justify="center">
				<v-col cols="12" md="4" sm="8">
					<v-card class="elevation-12">
						<v-toolbar color="primary" dark flat>
							<v-toolbar-title>Sign in / Sign on</v-toolbar-title>
							<v-spacer/>
						</v-toolbar>
						<v-card-text>
							<v-form>
								<v-text-field
										:error="incorrectLogin"
										:rules="[ rules.required ]"
										clearable
										label="Login"
										name="login"
										prepend-icon="fa-user"
										type="text"
										v-model="login"
								/>

								<v-text-field
										:append-icon="visiblePassword"
										:error="incorrectPassword"
										:rules="[ rules.required ]"
										:type="showPassword ? 'text' : 'password'"
										@click:append="showPassword = !showPassword"
										label="Password"
										name="password"
										prepend-icon="fa-lock"
										v-model="password"
								/>
							</v-form>
						</v-card-text>
						<v-card-actions>
							<v-spacer/>
							<v-btn @click="handleSubmit" color="primary">Login</v-btn>
						</v-card-actions>
					</v-card>
				</v-col>
			</v-row>
			<v-dialog :disabled="!errorPassword" v-model="errorPassword">
				<v-card>
					<v-card-title class="headline grey"
								  primary-title>
						Неверный пароль
					</v-card-title>

					<v-card-text>
						Введен неверный пароль
					</v-card-text>

					<v-divider/>

					<v-card-actions>
						<v-spacer/>
						<v-btn @click="errorPassword = false"
							   color="primary" text>
							Confirm
						</v-btn>
					</v-card-actions>
				</v-card>
			</v-dialog>
		</v-container>
	</v-content>
</template>

<script>
    import {mapActions, mapState} from "vuex";

    export default {
        name: "Login",
        data() {
            return {
                login: '',
                password: '',
                showPassword: false,
                incorrectLogin: false,
                incorrectPassword: false,
                errorPassword: false,
                rules: {
                    required: value => !!value || 'Обзательное поле.',
                }
            };
        },
        computed: {
            ...mapState(['profile']),
            visiblePassword() {
                return this.showPassword ? 'fa-eye' : 'fa-eye-slash';
            }
        },
        methods: {
            ...mapActions(['loginUserAction']),
            handleSubmit(e) {
                const payload = {
                    login: this.login,
                    password: this.password
                };
                this.incorrectLogin = false;
                this.incorrectPassword = false;
                if (this.login && this.password) {
                    this.loginUserAction({
                        payload: payload, errorHandler: () => {
                            this.errorLogin();
                        }
                    })
                }

                if (!this.login) {
                    this.incorrectLogin = true;
                }
                if (!this.password) {
                    this.incorrectPassword = true;
                }
            },
            errorLogin() {
                this.errorPassword = true;
            }
        },
        beforeMount() {
            if (this.profile) {
                this.$router.replace('/')
            }
        }
    }
</script>

<style scoped>

</style>